package proiect;

import java.awt.event.ActionListener;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

public class Form {
	static JFrame frame;
	static JPanel root;
	public JTextField fSpecies;
	public JTextField fName;
	public JCheckBox fIsCarnivore;

	public Form(ActionListener onSave, ActionListener onCancel) {
		buildForm(onSave, onCancel);
	}

	public Form(ActionListener onSave, ActionListener onCancel, Animal prefill) {
		buildForm(onSave, onCancel);

		fSpecies.setText(prefill.species);
		fName.setText(prefill.name);
		fIsCarnivore.setSelected(prefill.isCarnivore);
	}

	private void buildForm(ActionListener onSave, ActionListener onCancel) {
		frame = new JFrame("Add/Edit object");
		root = new JPanel();
		root.setLayout(new BoxLayout(root, BoxLayout.Y_AXIS));

		JPanel pSpecies = new JPanel();
		pSpecies.add(new JLabel("Species: "));
		fSpecies = new JTextField(20);
		pSpecies.add(fSpecies);
		root.add(pSpecies);

		JPanel pName = new JPanel();
		pName.add(new JLabel("Name: "));
		fName = new JTextField(20);
		pName.add(fName);
		root.add(pName);

		JPanel pIsCarnivore = new JPanel();
		pIsCarnivore.add(new JLabel("Carnivore: "));
		fIsCarnivore = new JCheckBox();
		pIsCarnivore.add(fIsCarnivore);
		root.add(pIsCarnivore);

		JPanel pButtons = new JPanel();
		JButton bSave = new JButton("Save");
		JButton bCancel = new JButton("Cancel");
		bSave.addActionListener(onSave);
		bCancel.addActionListener(onCancel);
		pButtons.add(bSave);
		pButtons.add(bCancel);
		root.add(pButtons);

		frame.add(root);
		frame.setSize(500, 200);
		frame.setVisible(true);
	}

	public void destroy() {
		frame.setVisible(false);
		frame.removeAll();
	}
}
