package proiect;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BoxLayout;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;

public class ListObjects {
	static JFrame frame;
	static JPanel root;
	static JList<String> list;
	DefaultListModel<String> listData;

	private Store store;

	private Form editForm;

	public ListObjects(Store store) {
		this.store = store;

		frame = new JFrame("List objects");
		root = new JPanel();
		root.setLayout(new BoxLayout(root, BoxLayout.Y_AXIS));

		JPanel pList = new JPanel();
		listData = new DefaultListModel<String>();
		list = new JList<String>(listData);
		list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		new JScrollPane(list);
		list.setPreferredSize(new Dimension(220, 450));
		pList.add(list);
		root.add(pList);

		JPanel pButtons = new JPanel();
		JButton bEdit = new JButton("Edit");
		JButton bDelete = new JButton("Delete");
		JButton bBack = new JButton("Close");
		bEdit.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				if (!list.isSelectionEmpty()) {
					editForm = new Form(onEditSave(), onEditCancel(), store.get(list.getSelectedIndex()));
				}
			}
		});
		bDelete.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				store.remove(list.getSelectedIndex());
				list.clearSelection();
				loadData();
			}
		});
		bBack.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				frame.setVisible(false);
				frame.removeAll();
			}
		});
		pButtons.add(bEdit);
		pButtons.add(bDelete);
		pButtons.add(bBack);
		root.add(pButtons);

		frame.add(root);
		frame.setSize(250, 500);
		frame.setVisible(true);

		loadData();
	}

	private void loadData() {
		list.clearSelection();
		listData.clear();
		for (Animal animal : store.getAnimals()) {
			listData.addElement(animal.toString());
		}
	}

	private ActionListener onEditSave() {
		return new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				store.update(list.getSelectedIndex(), new Animal(editForm.fSpecies.getText(), editForm.fName.getText(),
						editForm.fIsCarnivore.isSelected()));
				editForm.destroy();
				editForm = null;
				list.clearSelection();
				loadData();
			}
		};
	}

	private ActionListener onEditCancel() {
		return new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				editForm.destroy();
				editForm = null;
			}
		};
	}
}
